Educational Codeforces Round 118 (Rated for Div. 2) C. Poisoned Dagger(二分或搜索)

C. Poisoned Dagger
题意:
Monocarp is playing yet another computer game. In this game, his character has to kill a dragon. The battle with the dragon lasts 100500 seconds, during which Monocarp attacks the dragon with a poisoned dagger. The i-th attack is performed at the beginning of the ai-th second from the battle start. The dagger itself does not deal damage, but it applies a poison effect on the dragon, which deals 1 damage during each of the next k seconds (starting with the same second when the dragon was stabbed by the dagger). However, if the dragon has already been poisoned, then the dagger updates the poison effect (i.e. cancels the current poison effect and applies a new one).

For example, suppose k=4, and Monocarp stabs the dragon during the seconds 2, 4 and 10. Then the poison effect is applied at the start of the 2-nd second and deals 1 damage during the 2-nd and 3-rd seconds; then, at the beginning of the 4-th second, the poison effect is reapplied, so it deals exactly 1 damage during the seconds 4, 5, 6 and 7; then, during the 10-th second, the poison effect is applied again, and it deals 1 damage during the seconds 10, 11, 12 and 13. In total, the dragon receives 10 damage.

Monocarp knows that the dragon has h hit points, and if he deals at least h damage to the dragon during the battle — he slays the dragon. Monocarp has not decided on the strength of the poison he will use during the battle, so he wants to find the minimum possible value of k (the number of seconds the poison effect lasts) that is enough to deal at least h damage to the dragon.

Input
The first line contains a single integer t (1≤t≤1000) — the number of test cases.

The first line of the test case contains two integers n and h (1≤n≤100;1≤h≤1018) — the number of Monocarp’s attacks and the amount of damage that needs to be dealt.

The second line contains n integers a1, a2, …, an (1≤ai≤109;ai

Output
For each test case, print a single integer — the minimum value of the parameter k, such that Monocarp will cause at least h damage to the dragon.

大体意思就是要用毒击杀一只dragon(总血量h),毒性是每秒减1滴血,给出每次下毒的时间(n个时间),要求找出一个最小毒性持续的时间k,使得分别在下毒的时间下完毒后能杀死dragon。(第一次下完毒之后,第二次下毒时如果第一次的毒还没完全持续完,那么毒性不会叠加,而是更新,仍然是掉1滴血,持续k秒)

解法一:二分。
思路,这道题如果数据不是long long的话,我们可以直接从1开始到10^9遍历,找到其中的一个数符合题意,但对于这道题这样肯定会超时,所以可以使用二分去找k(符合题意的最小的数)。

#include 
//dfs 大法师
#define ll long long
using namespace std;
const int mod=20100403;
const int Inf=0x3f3f3f3f;
inline int read()
{
	int x=0,f=1;char ch=getchar();
	while (!isdigit(ch)){if (ch=='-') f=-1;ch=getchar();}
	while (isdigit(ch)){x=x*10+ch-48;ch=getchar();}
	return x*f;
}
ll n,k,x[101];
bool solve(ll ans)
{
    ll sum=0;
    for(int a=0;a<n-1;a++)
    {
        if(x[a+1]-x[a]<ans)sum+=x[a+1]-x[a];
        else sum+=ans;
    }
    sum+=ans;
    return sum>=k;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    while(t--)
    {
        cin>>n>>k;
        for(int a=0;a<n;a++)
            cin>>x[a];
        ll l=0,r=1e18+1;
        while(l<r)
        {
            ll mid=(l+r)>>1;
            if(solve(mid))r=mid;
            else l=mid+1;
        }
        cout<<r<<endl;
    }
    return 0;
}

解法二:搜索
当时看到这道题,首先想的不是二分,而是搜索。

我们先让d=h/n,这是平均时间,如果每段时间长都大于d,那么符合题意,直接输出;如果有一些时间段a小于d,这时我们要找的k必然会大于d,所以先用总时间h减去a(因为dragon在这个时间段最多就能掉a滴血),然后再在剩下的大于d的区间内重复上述过程(即找平均值,判断每个区间是否都大于平均值)

solve(还剩余的总血量,几个时间段大于d,每个时间段所能减掉dragon的血量,还剩几个时间段)。

代码如下:

#include 
//dfs 大法师
#define ll long long
using namespace std;
const int mod=20100403;
const int Inf=0x3f3f3f3f;
inline int read()
{
	int x=0,f=1;char ch=getchar();
	while (!isdigit(ch)){if (ch=='-') f=-1;ch=getchar();}
	while (isdigit(ch)){x=x*10+ch-48;ch=getchar();}
	return x*f;
}
ll n,k,x[101];
void solve(ll sum,ll ans,ll y[],ll ann)
{
    ll d;
    ll dd=0;
    ll ddd=0;
    ll p=0;
    if(sum%ans==0)d=sum/ans;
    else d=sum/ans+1;
    ll z[101];
    for(int a=0;a<ann;a++)
    {
        if(y[a]<d)dd+=y[a];
        else {ddd++;z[p++]=y[a];}
    }
    ddd++;
    if(ddd==ann+1){cout<<d<<endl;return;}
    else
    {
        solve(sum-dd,ddd,z,p);
    }

}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    while(t--)
    {
        ll y[101];
        ll ans=0;
        ll ann=0;
       cin>>n>>k;
       for(int a=0;a<n;a++)cin>>x[a];
       for(int a=0;a<n-1;a++){
        y[ans++]=x[a+1]-x[a];ann++;
       }
       solve(k,n,y,ann);
    }
    return 0;
}

你可能感兴趣的:(CF题解,c++,算法)